#ifndef SECTIONTOEXECUTE_SEEN
#define SECTIONTOEXECUTE_SEEN

#include "nomDeLogiciel.h"
#include "abstractElement.h"
#include "abstractSoftware.h"

class sectionToExecute
{
 public :

  /** Create a new sectionToExecute and initialize it with the given element and software
   */
  sectionToExecute(abstractElement*,abstractSoftware*);
  
  /** Deprecated : To be removed ! */
  sectionToExecute(abstractElement*, int, abstractElement*, int, abstractSoftware*);

  ~sectionToExecute() {;}

  inline abstractSoftware* getSoftware() const {
    return software_;
  }
  
  inline void setSoftware(abstractSoftware* soft) {
    software_ = soft;
  }
  
/**
 Set a software according to the corresponding given string.
 If not found, set a softwareUnknown
 */
  void setSoftware(std::string);

  /**
   Get the vector of elements of this sector
   */
  inline std::vector< abstractElement* > getElements() {return elements_;};
  
  /**
   Get the last element of this section
   */
  inline abstractElement*  getLastElement() {return elements_.back();};
  
  /**
   Remove the last element of this section
   */
  inline void removeLastElement() {return elements_.pop_back();};

  bool insertAfter(abstractElement*,abstractElement*);

  inline bool insertAtFirst(abstractElement* abs) {
    elements_.insert ( elements_.begin() ,abs);
  };
  
  private :

  abstractSoftware* software_;

  std::vector< abstractElement* > elements_;
};
#endif
