//
//  sector.cpp
//  PSPA
//
//  Created by Garnier Laurent on 10/12/13.
//  Copyright (c) 2013 Garnier Laurent. All rights reserved.
//

#include "sector.h"

#include "sectionToExecute.h"
#include "dataManager.h"

sector::sector(dataManager* data, std::string name):
reflected_(false),
duplicatedFrom_(NULL),
repetitionNumber_(1),
name_(name),
dataManager_(data),
sectorParam_(this)
{
  
}

sector::~sector()  {
}

void sector::addElementAfter(abstractElement* currentElement ,abstractElement* previousElement){
// if the previous element is NULL, it will try to add at the beginning of the first section
  
  if (previousElement == NULL) {
    if (sectionToExecute_.size() == 0) {
      sectionToExecute_.push_back(new sectionToExecute(currentElement,NULL));
    } else {
        sectionToExecute* section = sectionToExecute_.front();
      section->insertAtFirst(currentElement);
    }
  } else {
 
    for (unsigned int i=0; i<sectionToExecute_.size(); i++) {
      sectionToExecute* section = sectionToExecute_[i];
      if (section->insertAfter(previousElement,currentElement)) {
        return;
      }
    }
  }
}

void sector::clearSectionToExecute()
{
  unsigned k;
  for(k = 0; k < sectionToExecute_.size(); k++)
  {
    if ( sectionToExecute_[k] != NULL ) clearSectionToExecute(k);
  }
  sectionToExecute_.clear();
}

void sector::clearSectionToExecute(int a)
{
  cout << " dataManager::clearSectionToExecute : effacement de la section d'index = " << a << endl;
  if (a < 0) return;
  if (a >= (int)sectionToExecute_.size()) return;
  
  // lors de la creation de la section on a fait un 'new' d'un
  // softwareXXXX : on fait ici le 'delete'
  
  const abstractSoftware* soft = sectionToExecute_.at(a)->getSoftware();
  if ( soft != NULL ) delete soft;
  sectionToExecute_.erase (sectionToExecute_.begin()+a);
}
